﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using ServiceProvider;

namespace ServiceManager.Core.Tests.Mocks
{
    public class MockIService : IService
    {
        public MockIService()
        {
            StopHasBeenCalled = false;
            StartHasBeenCalled = false;
        }

        [ServiceStop]
        public virtual void Stop()
        {
            StopHasBeenCalled = true;
        }

        [ServiceStart]
        public virtual void Start()
        {
            StartHasBeenCalled = true;
        }

        public IServiceEventListener ServiceEventListener { get; set; }

        public bool IsNeededToBeStarted(out string reason)
        {
            throw new NotImplementedException();
        }

        public bool StopHasBeenCalled { get; private set; }
        public bool StartHasBeenCalled { get; private set; }
    }

    public class MockIService_InvalidSignatureForStart : IService
    {
        public MockIService_InvalidSignatureForStart()
        {
            StopHasBeenCalled = false;
            StartHasBeenCalled = false;
        }

        [ServiceStop]
        public virtual void Stop()
        {
            StopHasBeenCalled = true;
        }

        [ServiceStart]
        public virtual void Start( bool flag )
        {
            StartHasBeenCalled = true;
        }

        public IServiceEventListener ServiceEventListener { get; set; }

        public bool IsNeededToBeStarted(out string reason)
        {
            throw new NotImplementedException();
        }

        public bool StopHasBeenCalled { get; private set; }
        public bool StartHasBeenCalled { get; private set; }
    }
}
