﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using NUnit.Framework;

using ServiceManager.Core.Tests.Mocks;
using ServiceManager.Exceptions;

using ServiceProvider;

namespace ServiceManager.Core.Tests.ServiceProvider
{
    [TestFixture]
    public class ServiceTests
    {
        [Test]
        public void Run_EnsureThatWhenWeProvideAValidObject_StartHappens()
        {
            var myService = new MockIService();

            var service = new Service( myService );
            
            var serviceResult = new ServiceResult();
            var status = service.Run( serviceResult );

            Assert.That( status, Is.True );
            Assert.That( myService.StartHasBeenCalled, Is.True );
        }

        [Test, ExpectedException(typeof(UnableToStartServiceException))]
        public void Run_EnsureThatWhenWeProvideAInValidObject_StartThrowsException()
        {
            var myService = new MockIService_InvalidSignatureForStart();

            var service = new Service(myService);

            var serviceResult = new ServiceResult();
            service.Run(serviceResult);

        }
    }
}
