
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace ServiceManager.Exceptions
{
    [Serializable]
    public abstract class AbstractServiceConfigurationException : ApplicationException
    {
        private string serviceFullName;

        protected string ServiceFullName
        {
            get
            {
                return serviceFullName;
            }
        }

        #region constructors
        public AbstractServiceConfigurationException()
            : base()
        {
        }

        public AbstractServiceConfigurationException(string serviceName)
            : base()
        {
            serviceFullName = serviceName;
        }

        public AbstractServiceConfigurationException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
            serviceFullName = info.GetString("serviceFullName");
        }
  
        public override void GetObjectData(SerializationInfo info,
            StreamingContext context)
        {
            info.AddValue("serviceFullName", serviceFullName);
            base.GetObjectData(info, context);
        }   
        #endregion
 
    }
}
