
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace ServiceManager.Exceptions
{
    [Serializable]
    public class ConfiguratorNotSupportedException : AbstractServiceConfigurationException
    {
        #region constructors
        public ConfiguratorNotSupportedException()
            : base()
        {
        }

        public ConfiguratorNotSupportedException(string serviceName)
            : base(serviceName)
        {
        }

        public ConfiguratorNotSupportedException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

        #endregion

        public override string Message
        {
            get
            {
                return string.Format("Service {0} doesn't support configuration", base.ServiceFullName);
            }
        }
    }
}
