
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace ServiceManager.Exceptions
{
    [Serializable]
    public class ServiceNotFoundException : AbstractServiceConfigurationException
    {
        #region constructors
        public ServiceNotFoundException()
            : base()
        {
        }

        public ServiceNotFoundException(string serviceName)
            : base(serviceName)
        {
        }

        public ServiceNotFoundException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }      
        #endregion

        public override string Message
        {
            get
            {
                return string.Format("Could not find {0} service", base.ServiceFullName);
            }
        }   
    }
}
