
using System;
using System.Collections;

namespace ServiceProvider
{
    /// <summary>
	///	AbstractService Class.
	/// </summary>
	public abstract class AbstractService : MarshalByRefObject, IAbstractService
    {
		private string	m_fullName;
		private string	m_serviceName;

		private bool		m_started = false;

		protected AbstractService(string pathName, string serviceName) 
		{ 
			m_fullName		= pathName + "." + serviceName;
			m_serviceName = serviceName;
		}

		public AbstractService(string name)
		{
			m_fullName = m_serviceName = name;
		}

		public string FullName 
		{
			get { return m_fullName; }
		}

		public string Name
		{
			get { return m_serviceName; }
		}

		public override Object InitializeLifetimeService()
		{
			System.Runtime.Remoting.Lifetime.ILease lease = (System.Runtime.Remoting.Lifetime.ILease) base.InitializeLifetimeService();
			if (lease.CurrentState ==	System.Runtime.Remoting.Lifetime.LeaseState.Initial)
			{
				lease.InitialLeaseTime = TimeSpan.Zero;
			}

			return lease;
		}

		public abstract ServiceResult Run(IServiceEventListener listener);

		public bool Started
		{
			get { return m_started; }
			set { m_started = value; }
		}
	}
}
