using System;
using System.Configuration;
using System.Xml;

namespace ServiceProvider
{
    /// <summary>
    /// ServiceConfigManager: Class that contains properties for the data kept 
    /// in the config file for each service.
    /// </summary>
    public class ServiceConfigManager : System.Collections.CollectionBase
    {

        public ServiceConfigManager(XmlNodeList serviceNodes)
        {
            Initialize(serviceNodes);
        }

        public static ServiceConfigManager Create()
        {
            return (ServiceConfigManager) ConfigurationSettings.GetConfig("AppPlugins/Services");
        }

        protected void Initialize(XmlNodeList serviceList)
        {
            int count = serviceList.Count;
            for(int i=0; i<count; i++)
            {
                try
                {
                    if (serviceList[i] is System.Xml.XmlWhitespace)
                        continue;

                    string assembly	= ((XmlAttribute) serviceList[i].Attributes["assemblyName"]).Value;
                    base.InnerList.Add(assembly);
                }
                catch(Exception)
                {
                    // Suppress error and move on.
                }
            }
        }

        public string this[int index]
        {
            get 
            {
                return (string) base.InnerList[index];
            }
        }
    }
}