
using System;

namespace ServiceProvider
{
	/// <summary>
	/// ServiceProviderAttribute
	/// </summary>
	/// <example>
	/// [ServiceProvider.Service]
	/// public class ExampleClass 
	/// {}
	/// </example>
	[AttributeUsage(AttributeTargets.Class, AllowMultiple=false, Inherited=true)]
	public class ServiceAttribute : Attribute
	{
		protected bool m_autoStart = false;

		public ServiceAttribute() : base()
		{
		}

		public ServiceAttribute(bool autoStart) : base()
		{
			m_autoStart = autoStart;
		}

		public bool AutoStart
		{
			get { return m_autoStart; }
		}
	}
}
