
using System;

namespace ServiceProvider
{
	/// <summary>
	/// Summary description for ServiceResult.
	/// </summary>
	/// 
	[Serializable]
	public class ServiceResult
	{
		private bool				m_isFailure = false; 
		private DateTime			m_startTime;
		private DateTime			m_stopTime;
		private string				m_name;

		public ServiceResult() : this(string.Empty)
		{
		}

		public ServiceResult(string name)
		{
			m_name		= name;
		}

		public virtual string Name
		{
			get { return m_name; }
			set { m_name = value; }
		}

		public virtual bool IsSuccess
		{
			get { return !(m_isFailure); }
		}
		
		public virtual bool IsFailure
		{
			get { return m_isFailure; }
			set { m_isFailure = value; }
		}

		public double Time 
		{
			get
			{ 
				DateTime stop = m_stopTime;
				TimeSpan span = stop.Subtract(m_startTime);
				return (double) span.Ticks / (double)TimeSpan.TicksPerSecond;
			}
		}

		public DateTime StartTime 
		{
			get{ return m_startTime; }
			set{ m_startTime = value; }
		}

		public DateTime StopTime 
		{
			get{ return m_stopTime; }
			set{ m_stopTime = value; }
		}
	}
}
