

using System;
using System.Collections.Generic;
using System.Text;

using ServiceProvider;
using ServiceManager.Exceptions;

namespace ServiceManager
{
    public class ServicesConfigurationManager : MarshalByRefObject
    {
        public ServicesConfigurationManager() {}

        public void StartService(string serviceFullName)
        {
            ServiceLoader.Instance.ChangeServiceStatus(SearchForServiceToConfigure(serviceFullName), true);
        }

        public void StopService(string serviceFullName)
        {
            ServiceLoader.Instance.ChangeServiceStatus(SearchForServiceToConfigure(serviceFullName), false);
        }

        public MarshalByRefObject GetServiceConfiguration(string serviceFullName) 
        {
            return SearchForServiceToConfigure(serviceFullName).Service.GetServiceConfigurator();
        }    
   
        private ServiceInfo SearchForServiceToConfigure(string serviceFullName)
        {
            foreach (ServiceInfo serviceInfo in ServiceLoader.Instance.ServicesList)
            {
                if (serviceInfo.ServiceName == serviceFullName)
                    return serviceInfo;

            }

            ServiceLoader.LogEntry(string.Format("Service {0} not found.", serviceFullName));
            throw new ServiceNotFoundException(serviceFullName);
        }

    }
}
